Ruby: pm_capture_pattern_node Struct Reference

Ruby 4.0.6p0 (2026-07-14 revision 03b6d3f8898a28604fe6cb00eae3226b821168f4)

Data Fields
pm_capture_pattern_node Struct Reference

CapturePatternNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | value
| CapturePatternNode#value.
struct pm_local_variable_target_node * | target
| CapturePatternNode#target.
pm_location_t | operator_loc
| CapturePatternNode#operator_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

CapturePatternNode.

Represents assigning to a local variable in pattern matching.

    foo => [bar => baz]
           ^^^^^^^^^^^^

Type: ::PM_CAPTURE_PATTERN_NODE

Definition at line 2528 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_capture_pattern_node::base

The embedded base node.

Definition at line 2530 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_capture_pattern_node::operator_loc

CapturePatternNode#operator_loc.

Represents the location of the => operator.

    foo => bar
        ^^

Definition at line 2561 of file ast.h.

Referenced by pm_dump_json().

## ◆ target

struct pm_local_variable_target_node* pm_capture_pattern_node::target

CapturePatternNode#target.

Represents the target of the capture.

    foo => bar
    ^^^

Definition at line 2551 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_capture_pattern_node::value

CapturePatternNode#value.

Represents the value to capture.

    foo => bar
           ^^^

Definition at line 2541 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h